﻿' --------------------------------------------------------------------------------------------------------------------
' <copyright file="Form1.cs" company="">
'   
' </copyright>
' <summary>
'   The form 1.
' </summary>
' --------------------------------------------------------------------------------------------------------------------
Imports System.ComponentModel
Imports Telerik.WinControls.UI
Imports Telerik.WinControls

''' <summary>
''' The form 1.
''' </summary>
Partial Public Class Form1
    Inherits RadForm

#Region "Constants and Fields"

    ''' <summary>
    ''' The rad grid view 1.
    ''' </summary>
    Private WithEvents RadGridView1 As DraggableGridView

    ''' <summary>
    ''' The rad grid view 2.
    ''' </summary>
    Private WithEvents RadGridView2 As DraggableGridView

#End Region

#Region "Constructors and Destructors"

    ''' <summary>
    ''' Initializes a new instance of the <see cref="Form1"/> class.
    ''' </summary>
    Public Sub New()
        Me.InitializeComponent()
        Me.Text = "Drag Drop Bound mode example"
        Me.Size = New Size(800, 600)
        Me.RadGridView1 = New DraggableGridView()
        RadGridView1.AllowAddNewRow = False
        RadGridView1.Dock = DockStyle.Fill
        Me.RadGridView2 = New DraggableGridView()
        RadGridView2.AllowAddNewRow = False
        RadGridView2.Dock = DockStyle.Fill

        Dim radGroupSource = New RadGroupBox()
        radGroupSource.HeaderText = "SourceGrid"

        Dim radGroupTarget = New RadGroupBox()
        radGroupTarget.HeaderText = "TargetGrid"

        Me.RadGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill
        radGroupSource.Controls.Add(Me.RadGridView1)

        Me.RadGridView2.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill
        radGroupTarget.Controls.Add(Me.RadGridView2)

        radGroupSource.Location = New Point(0, 0)
        radGroupSource.Size = New Size(Me.ClientSize.Width / 2, Me.ClientSize.Height)
        radGroupTarget.Location = New Point(Me.ClientSize.Width / 2, 0)
        radGroupTarget.Size = New Size(Me.ClientSize.Width / 2, Me.ClientSize.Height)

        radGroupSource.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top Or AnchorStyles.Bottom
        radGroupTarget.Anchor = AnchorStyles.Left Or AnchorStyles.Right Or AnchorStyles.Top Or AnchorStyles.Bottom

        Dim tableLayout = New TableLayoutPanel()
        tableLayout.Dock = DockStyle.Fill
        tableLayout.RowStyles.Add(New RowStyle(SizeType.Percent, 100.0F))
        tableLayout.ColumnStyles.Add(New ColumnStyle(SizeType.Percent, 50.0F))
        tableLayout.ColumnStyles.Add(New ColumnStyle(SizeType.Percent, 50.0F))
        tableLayout.Controls.Add(radGroupSource, 0, 0)
        tableLayout.Controls.Add(radGroupTarget, 1, 0)
        Me.Controls.Add(tableLayout)

    End Sub

#End Region

#Region "Methods"

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        LoadDataSetDataSource()
        'LoadBusinessObjectsDataSource()
    End Sub

    Private Sub LoadBusinessObjectsDataSource()
        Me.Text += " - Bussiness Objects"
        Me.RadGridView1.DataSource = New TestsCollection(10, 1)
        Me.RadGridView2.DataSource = New TestsCollection(10, 10)
    End Sub

    Private Sub LoadDataSetDataSource()
        Me.Text += " - DataSet"
        Me.RadGridView1.DataSource = GetDataSet()
        Me.RadGridView1.DataMember = "Table1"
        Me.RadGridView2.DataSource = GetDataSet()
        Me.RadGridView2.DataMember = "Table1"
    End Sub

    Private Shared Function GetDataSet() As DataSet
        Dim dataSet = New DataSet()
        '
        ' Here we create a DataTable with four columns.
        '
        Dim table As New DataTable()
        table.Columns.Add("Dosage", GetType(Integer))
        table.Columns.Add("Drug", GetType(String))
        table.Columns.Add("Patient", GetType(String))
        table.Columns.Add("Date", GetType(DateTime))

        '
        ' Here we add five DataRows.
        '
        table.Rows.Add(25, "Indocin", "David", DateTime.Now)
        table.Rows.Add(50, "Enebrel", "Sam", DateTime.Now)
        table.Rows.Add(10, "Hydralazine", "Christoff", DateTime.Now)
        table.Rows.Add(21, "Combivent", "Janet", DateTime.Now)
        table.Rows.Add(100, "Dilantin", "Melanie", DateTime.Now)

        dataSet.Tables.Add(table)

        Return dataSet
    End Function

#End Region
End Class

''' <summary>
''' The draggable grid view.
''' </summary>
Public Class DraggableGridView
    Inherits RadGridView

#Region "Constructors and Destructors"

    Dim WithEvents dragDropService As RadGridViewDragDropService

    ''' <summary>
    ''' Initializes a new instance of the <see cref="DraggableGridView"/> class.
    ''' </summary>
    Public Sub New()
        ' comment this line to disable multi selection
        Me.MultiSelect = True
        Me.ReadOnly = True

        dragDropService = Me.GridViewElement.GetService(Of RadGridViewDragDropService)()

        Dim gridBehavior = TryCast(Me.GridBehavior, BaseGridBehavior)
        gridBehavior.UnregisterBehavior(GetType(GridViewDataRowInfo))
        gridBehavior.RegisterBehavior(GetType(GridViewDataRowInfo), New MyGridDataRowBehavior())
    End Sub

#End Region

#Region "Properties"

    ''' <summary>
    ''' Gets ThemeClassName.
    ''' </summary>
    Public Overrides Property ThemeClassName() As String
        Get
            Return GetType(RadGridView).FullName
        End Get

        Set(ByVal value As String)

        End Set
    End Property

#End Region

#Region "Methods"

    ''' <summary>
    ''' The draggable grid view_ row formatting.
    ''' </summary>
    ''' <param name="sender">
    ''' The sender.
    ''' </param>
    ''' <param name="e">
    ''' The e.
    ''' </param>
    Private Sub DraggableGridView_RowFormatting(ByVal sender As Object, ByVal e As RowFormattingEventArgs) _
        Handles MyBase.RowFormatting
        e.RowElement.AllowDrag = True
        e.RowElement.AllowDrop = True
    End Sub

    ''' <summary>
    ''' The get target row index.
    ''' </summary>
    ''' <param name="row">
    ''' The row.
    ''' </param>
    ''' <param name="dropLocation">
    ''' The drop location.
    ''' </param>
    ''' <returns>
    ''' The get target row index.
    ''' </returns>
    Private Function GetTargetRowIndex(ByVal row As GridDataRowElement, ByVal dropLocation As Point) As Integer
        Dim halfHeight As Integer = row.Size.Height / 2
        Dim index As Integer = row.RowInfo.Index
        If dropLocation.Y > halfHeight Then
            index += 1
        End If

        Return index
    End Function

    ''' <summary>
    ''' The move rows.
    ''' </summary>
    ''' <param name="targetGrid">
    ''' The target grid.
    ''' </param>
    ''' <param name="dragGrid">
    ''' The drag grid.
    ''' </param>
    ''' <param name="dragRows">
    ''' The drag rows.
    ''' </param>
    ''' <param name="index">
    ''' The index.
    ''' </param>
    Private Sub MoveRows(ByVal targetGrid As RadGridView, ByVal dragGrid As RadGridView, _
                          ByVal dragRows As IList(Of GridViewRowInfo), ByVal index As Integer)
        dragGrid.BeginUpdate()
        targetGrid.BeginUpdate()
        For i As Integer = dragRows.Count - 1 To 0 Step -1
            Dim row As GridViewRowInfo = dragRows(i)
            If TypeOf row Is GridViewSummaryRowInfo Then
                Continue For
            End If

            If GetType(DataSet).IsAssignableFrom(targetGrid.DataSource.[GetType]()) Then
                ' customize data set tables here if required
                Dim sourceTable = DirectCast(dragGrid.DataSource, DataSet).Tables(0)
                Dim targetTable = DirectCast(targetGrid.DataSource, DataSet).Tables(0)

                Dim newRow = targetTable.NewRow()
                For Each cell As GridViewCellInfo In row.Cells
                    newRow(cell.ColumnInfo.Name) = cell.Value
                Next

                sourceTable.Rows.Remove(DirectCast(row.DataBoundItem, DataRowView).Row)
                targetTable.Rows.InsertAt(newRow, index)
            ElseIf GetType(IList).IsAssignableFrom(targetGrid.DataSource.[GetType]()) Then
                Dim targetCollection = DirectCast(targetGrid.DataSource, IList)
                Dim sourceCollection = DirectCast(dragGrid.DataSource, IList)

                ' handle custom removing of data bound item here if necessary
                sourceCollection.Remove(row.DataBoundItem)

                ' format insert data here
                targetCollection.Add(row.DataBoundItem)
                ' handle custom data operations here
            Else
            End If

            index += 1
        Next

        dragGrid.EndUpdate(True)
        targetGrid.EndUpdate(True)
    End Sub

    ''' <summary>
    ''' The drag drop service_ preview drag drop.
    ''' </summary>
    ''' <param name="sender">
    ''' The sender.
    ''' </param>
    ''' <param name="e">
    ''' The e.
    ''' </param>
    Private Sub dragDropService_PreviewDragDrop(ByVal sender As Object, ByVal e As RadDropEventArgs) _
        Handles dragDropService.PreviewDragDrop

        Dim rowElement = TryCast(e.DragInstance, GridDataRowElement)
        If rowElement Is Nothing Then
            Return
        End If

        e.Handled = True

        Dim dropTarget = TryCast(e.HitTarget, RadItem)
        Dim targetGrid = TryCast(dropTarget.ElementTree.Control, RadGridView)
        If targetGrid Is Nothing Then
            Return
        End If

        Dim dragGrid = TryCast(rowElement.ElementTree.Control, RadGridView)

        If (targetGrid.Equals(dragGrid)) Then
            Return
        End If

        e.Handled = True
        Dim dropTargetRow = TryCast(dropTarget, GridDataRowElement)
        Dim _
            index As Integer = _
                If _
                (dropTargetRow IsNot Nothing, Me.GetTargetRowIndex(dropTargetRow, e.DropLocation), targetGrid.RowCount)

        Me.MoveRows(targetGrid, dragGrid, dragGrid.SelectedRows, index)

    End Sub

    ''' <summary>
    ''' The drag drop service_ preview drag hint.
    ''' </summary>
    ''' <param name="sender">
    ''' The sender.
    ''' </param>
    ''' <param name="e">
    ''' The e.
    ''' </param>
    Private Sub dragDropService_PreviewDragHint(ByVal sender As Object, ByVal e As PreviewDragHintEventArgs) _
        Handles dragDropService.PreviewDragHint
        Dim dataRowElement = TryCast(e.DragInstance, GridDataRowElement)
        ' set custom drag hint for multiple rows here
        'e.DragHint = new Bitmap(this.imageList1.Images[6]);
        'e.UseDefaultHint = false;
        If dataRowElement IsNot Nothing AndAlso dataRowElement.ViewTemplate.MasterTemplate.SelectedRows.Count > 1 Then
        End If
    End Sub

    ''' <summary>
    ''' The drag drop service_ preview drag over.
    ''' </summary>
    ''' <param name="sender">
    ''' The sender.
    ''' </param>
    ''' <param name="e">
    ''' The e.
    ''' </param>
    Private Sub dragDropService_PreviewDragOver(ByVal sender As Object, ByVal e As RadDragOverEventArgs) _
        Handles dragDropService.PreviewDragOver
        If TypeOf e.DragInstance Is GridDataRowElement Then
            e.CanDrop = TypeOf e.HitTarget Is GridDataRowElement OrElse TypeOf e.HitTarget Is GridTableElement OrElse _
                        TypeOf e.HitTarget Is GridSummaryRowElement
        End If
    End Sub

    ''' <summary>
    ''' The drag drop service_ preview drag start.
    ''' </summary>
    ''' <param name="sender">
    ''' The sender.
    ''' </param>
    ''' <param name="e">
    ''' The e.
    ''' </param>
    Private Sub dragDropService_PreviewDragStart(ByVal sender As Object, ByVal e As PreviewDragStartEventArgs) _
        Handles dragDropService.PreviewDragStart
        e.CanStart = True
    End Sub

#End Region

    ''' <summary>
    ''' The my grid data row behavior.
    ''' </summary>
    Private Class MyGridDataRowBehavior
        Inherits GridDataRowBehavior

#Region "Methods"

        ''' <summary>
        ''' The on mouse down left.
        ''' </summary>
        ''' <param name="e">
        ''' The e.
        ''' </param>
        ''' <returns>
        ''' The on mouse down left.
        ''' </returns>
        Protected Overrides Function OnMouseDownLeft(ByVal e As MouseEventArgs) As Boolean
            Dim dataRowElement = TryCast(Me.GetRowAtPoint(e.Location), GridDataRowElement)

            If dataRowElement IsNot Nothing Then
                Dim dragDropService = Me.GridViewElement.GetService(Of RadGridViewDragDropService)()
                dragDropService.Start(dataRowElement)
            End If

            Return MyBase.OnMouseDownLeft(e)
        End Function

#End Region
    End Class
End Class

''' <summary>
''' The test.
''' </summary>
Public Class Test

#Region "Constructors and Destructors"

    ''' <summary>
    ''' Initializes a new instance of the <see cref="Test"/> class.
    ''' </summary>
    ''' <param name="id">
    ''' The show all.
    ''' </param>
    ''' <param name="name">
    ''' The show part.
    ''' </param>
    Public Sub New(ByVal id As Integer, ByVal name As String)
        Me.Id = id
        Me.Name = name
    End Sub

#End Region

#Region "Properties"

    ''' <summary>
    ''' Gets or sets ShowAll.
    ''' </summary>
    Public Property Id() As Integer
        Get
            Return m_Id
        End Get
        Set(ByVal value As Integer)
            m_Id = value
        End Set
    End Property

    Private m_Id As Integer

    ''' <summary>
    ''' Gets or sets ShowPart.
    ''' </summary>
    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            m_Name = value
        End Set
    End Property

    Private m_Name As String

#End Region
End Class

''' <summary>
''' The tests collection.
''' </summary>
Public Class TestsCollection
    Inherits BindingList(Of Test)

#Region "Constructors and Destructors"

    ''' <summary>
    ''' Initializes a new instance of the <see cref="TestsCollection"/> class.
    ''' </summary>
    Public Sub New(ByVal noItems As Integer, ByVal startIndex As Integer)

        For i As Integer = startIndex To noItems + startIndex
            Me.Add(New Test(i, "Name" + i.ToString()))
        Next
    End Sub

#End Region
End Class
